#ifndef __QUEUE_CMD_H
#define __QUEUE_CMD_H

#include "FreeRTOS.h"
#include "task.h"
#include "semphr.h"

#include "config.h"

typedef enum
{
	INIT			= 0,
	RECORD			= 1,
	FS				= 2,
	MONO			= 3,
	FILTER			= 4,
	CLIP_DETECTION	= 5,
	PEAK_LEVEL_CH1	= 6,
	PEAK_LEVEL_CH2	= 7,
	SET_REGISTER	= 8,
	SAVE_CONFIG		= 9,
} QUEUE_CmdTypeDef;

typedef struct {
	QUEUE_CmdTypeDef cmd;
	uint8_t data[4];
} QUEUE_MsgTypeDef;

#if (CFG_AUDIO_OUT)
extern QueueHandle_t audio_out_queue;
#endif
#if (CFG_AUDIO_IN)
extern QueueHandle_t audio_in_queue;
#endif

int8_t sendQueueCmd(QueueHandle_t queue, QUEUE_CmdTypeDef cmd, uint8_t *data);

#endif
