/**
  ******************************************************************************
  * @file           : appjmp.c
  * @brief          : Application jump
  ******************************************************************************
  */
#include "main.h"
#include "appjmp.h"
#include <stdio.h>
#include <string.h>

uint32_t dfu_mode __attribute__((section(".uninit_data")));

void jumpTo(uint32_t base_addr)
{
printf("JumpToBootLoader\r\n");
	__disable_irq();
	for (int i = 0; i < sizeof(NVIC->ICER) / sizeof(NVIC->ICER[0]); i++) {
		NVIC->ICER[i]=0xFFFFFFFF;
		NVIC->ICPR[i]=0xFFFFFFFF;
	}
	__set_CONTROL(0);
	__set_MSP(*(__IO uint32_t*)base_addr);
	uint32_t jumpAddress = *((volatile uint32_t*) (base_addr + 4));
	__ISB();
	__DSB();
	SysTick->CTRL &= ~(SysTick_CTRL_CLKSOURCE_Msk | SysTick_CTRL_ENABLE_Msk);
	SCB->VTOR = base_addr + 4;
	/* Re-enable all interrupts */
	__enable_irq();
	void (*reset_handler)(void) = (void*)jumpAddress;
	while(1)
	   reset_handler();
}
