#include "main.h"
#include "queue_cmd.h"
#include <stdio.h>
/**
  * @brief  Send queue command
  * @param  queue: queue
  * @param  cmd: command
  * @param  data: pointer to command data
  * @retval USBD_OK if all operations are OK else USBD_FAIL
  */
int8_t sendQueueCmd(QueueHandle_t queue, QUEUE_CmdTypeDef cmd, uint8_t *data)
{
	QUEUE_MsgTypeDef msg;
	msg.cmd = cmd;
	switch (cmd) {
	case FS:
		msg.data[0] = data[0];
		msg.data[1] = data[1];
		msg.data[2] = data[2];
		msg.data[3] = data[3];
		break;
	case SET_REGISTER:
		msg.data[0] = data[0];
		msg.data[1] = data[1];
		msg.data[2] = data[2];
		break;
	case CLIP_DETECTION:
		msg.data[0] = data[0];
		msg.data[1] = data[1];
		break;
	case MONO:
	case FILTER:
	case PEAK_LEVEL_CH1:
	case PEAK_LEVEL_CH2:
		msg.data[0] = data[0];
		break;
	default:
		break;
	}
	return xQueueSendToBackFromISR(queue, &msg, 0U);
}
